﻿Public Class Form1
    Dim YrNum As Long, MonthNum As Long, DayNum As Long, MonthDays As Integer, StartNum As Integer
    Dim StartDate As Date, SelectedDate As Date, ButtonNum As Integer, CurMonth As Boolean
    Dim Cella(42) As Label

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        ' Creazione label indicizzate usabili come in VB6
        Dim indice As Integer = 0
        Dim offsetLEFT As Integer = 70
        Dim offsetTOP As Integer = 118
        For riga = 0 To 5
            For colonna = 0 To 6
                Cella(indice) = New Label
                Cella(indice).Top = 56 * riga + offsetTOP
                Cella(indice).Left = 77 * colonna + offsetLEFT
                Cella(indice).Size = New Size(62, 42)
                Cella(indice).BorderStyle = BorderStyle.FixedSingle
                Cella(indice).Tag = indice
                Cella(indice).TextAlign = ContentAlignment.MiddleCenter
                Me.Controls.Add(Cella(indice))
                AddHandler Cella(indice).Click, AddressOf Cella_Click
                indice += 1
                If indice > 37 Then Exit For ' le celle superflue non vengono create
            Next colonna
        Next riga
        '-------------------------------------------------

        Me.Label1.Text = ""
        Me.Label2.Text = ""
        YrNum = Now.Year
        DayNum = Now.Day
        MonthNum = Now.Month - 1 ' meno 1 perché verrà incrementato da ButtMESEpiu_Click
        ButtonNum = 1
        StartDate = Today
        DateLabel.Text = "Oggi " & StartDate
        ButtMESEpiu_Click(ButtMESEpiu, New EventArgs)
    End Sub

    Private Sub Cella_Click(sender As Object, e As EventArgs)
        ' su sender la label cliccata
        ' su sender.tag l'indice inserito in fase di creazione label
        sender.ForeColor = Color.Red
        SelectedDate = sender.Text & "/" & MonthNum & "/" & YrNum
        SwitchBack()
        ButtonNum = sender.tag
    End Sub

    Private Sub ButtMESEpiu_Click(sender As Object, e As EventArgs) Handles ButtMESEpiu.Click
        MonthNum += 1
        If MonthNum = 13 Then
            YrNum = YrNum + 1
            MonthNum = 1
        End If

        StartDate = 1 & "/" & MonthNum & "/" & YrNum
        UpDateDisplay()
    End Sub

    Private Sub ButMESEmeno_Click(sender As Object, e As EventArgs) Handles ButMESEmeno.Click
        MonthNum -= 1
        If MonthNum = 0 Then
            YrNum = YrNum - 1
            MonthNum = 12
        End If

        StartDate = 1 & "/" & MonthNum & "/" & YrNum
        UpDateDisplay()
    End Sub

    Private Sub ButANNOmeno_Click(sender As Object, e As EventArgs) Handles ButANNOmeno.Click
        StartDate = StartDate.AddYears(-1)
        YrNum = StartDate.Year
        UpDateDisplay()
    End Sub

    Private Sub ButANNOpiu_Click(sender As Object, e As EventArgs) Handles ButANNOpiu.Click
        StartDate = StartDate.AddYears(1)
        YrNum = StartDate.Year
        UpDateDisplay()
    End Sub

    Sub UpDateDisplay()
        StartNum = DateAndTime.Weekday(StartDate, FirstDayOfWeek.Monday) - 1 ' Domenica = 6, Lunedi = 0
        MonthDays = DateTime.DaysInMonth(YrNum, MonthNum)
        If DateTime.DaysInMonth(YrNum, 2) = 29 Then Label1.Text = "Bisestile" Else Label1.Text = ""
        Dim X As Integer

        If MonthNum = Now.Month And YrNum = Now.Year Then
            CurMonth = True
        Else
            CurMonth = False
        End If

        SelectedDateLabel.Text = StartDate.ToString("Y") ' visualizza mese e anno

        ' Le celle superflue invisibili *********************************
        For X = 0 To StartNum
            Cella(X).Visible = False
        Next X
        For X = StartNum + MonthDays - 1 To 37
            Cella(X).Visible = False
        Next X

        'Rietichettare e visualizzare le celle *******************************
        For X = StartNum To StartNum + MonthDays - 1
            Cella(X).Visible = True
            Cella(X).Text = X - StartNum + 1
            If CurMonth = True And X - StartNum + 1 = Now.Day Then
                Cella(X).ForeColor = Color.DarkBlue
                Cella(X).BackColor = Color.LightCyan
            Else
                If X Mod 7 = 6 Or X Mod 7 + 1 = 6 Then ' sabato e domenica
                    Cella(X).ForeColor = Color.DarkBlue
                    Cella(X).BackColor = Color.LightGray
                Else ' gli altri giorni
                    Cella(X).ForeColor = Color.DarkBlue
                    Cella(X).BackColor = Color.White
                End If
            End If
        Next X

        Label2.Text = StartDate
    End Sub

    Sub SwitchBack()
        Cella(ButtonNum).ForeColor = Color.DarkBlue ' ripristino colore
        SelectedDateLabel.Text = SelectedDate.ToLongDateString
        Label1.Text = "Tot Giorni = " & SelectedDate.DayOfYear.ToString
        Label2.Text = SelectedDate.DayOfWeek.ToString
    End Sub

End Class
